diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java
index 38c9c089e..4f512a8a9 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java
@@ -1,8 +1,7 @@
 package net.minecraft.core.item.block;
 
-import net.minecraft.core.block.BlockLayerBase;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.BlockLogicLayerBase;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
@@ -13,9 +12,9 @@ import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
 
-public class ItemBlockLayer extends ItemBlock
+public class ItemBlockLayer<T extends BlockLogicLayerBase> extends ItemBlock<T>
 {
-	public ItemBlockLayer(Block block)
+	public ItemBlockLayer(Block<T> block)
 	{
 		super(block);
 	}
@@ -23,27 +22,27 @@ public class ItemBlockLayer extends ItemBlock
 	@Override
 	public boolean onUseItemOnBlock(final ItemStack itemstack, final @Nullable Player player, final World world, int blockX, int blockY, int blockZ, final Side side, double xPlaced, final double yPlaced)
 	{
-		int id = world.getBlockId(blockX, blockY, blockZ);
+		Block<?> targetBlock = world.getBlock(blockX, blockY, blockZ);
 		int meta = world.getBlockMetadata(blockX, blockY, blockZ);
-		if (id != blockID && Blocks.blocksList[id] != null && Blocks.blocksList[id].hasTag(BlockTags.PLACE_OVERWRITES))
+		if (targetBlock != block && targetBlock != null && targetBlock.hasTag(BlockTags.PLACE_OVERWRITES))
 		{
-			id = 0;
+			targetBlock = null;
 			meta = 0;
 		}
 		if (itemstack.stackSize <= 0)
 		{
 			return false;
 		}
-		if (blockY == world.getHeightBlocks() - 1 && Blocks.blocksList[blockID].blockMaterial.isSolid())
+		if (blockY == world.getHeightBlocks() - 1 && block.getMaterial().isSolid())
 		{
 			return false;
 		}
 
 		// Check if we're placing "inside" a layer
-		if (id == blockID && side == Side.TOP)
+		if (targetBlock == block && side == Side.TOP)
 		{
 
-			final BlockLayerBase blockLayer = (BlockLayerBase) Blocks.blocksList[blockID];
+			final BlockLogicLayerBase blockLayer = block.getLogic();
 
 			final int newMeta = meta + 1;
 
@@ -55,40 +54,40 @@ public class ItemBlockLayer extends ItemBlock
 
 			if (newMeta < 7)
 			{
-				world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, newMeta);
+				world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, block.id(), newMeta);
 			}
 			else
 			{
-				if (blockLayer.getFullBlockID() != -1)
+				if (blockLayer.fullBlock != null)
 				{
-					world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockLayer.getFullBlockID(), 0);
+					world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockLayer.fullBlock.id(), 0);
 				}
 				else
 				{
-					world.setBlockAndMetadataWithNotify(blockX, blockY + 1, blockZ, blockID, 0);
+					world.setBlockAndMetadataWithNotify(blockX, blockY + 1, blockZ, block.id(), 0);
 				}
 			}
-			world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockLayer, EnumBlockSoundEffectType.PLACE);
+			world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
 			itemstack.consumeItem(player);
 			return true;
 
 		}
 
 		// Offset position
-		if (id != 0)
+		if (targetBlock != null)
 		{
 			blockX += side.getOffsetX();
 			blockY += side.getOffsetY();
 			blockZ += side.getOffsetZ();
-			id = world.getBlockId(blockX, blockY, blockZ);
+			targetBlock = world.getBlock(blockX, blockY, blockZ);
 			meta = world.getBlockMetadata(blockX, blockY, blockZ);
 		}
 
 		// Check if the block we're placing into is a layer
-		if (id == blockID)
+		if (targetBlock == block)
 		{
 
-			final BlockLayerBase blockLayer = (BlockLayerBase) Blocks.blocksList[blockID];
+			final BlockLogicLayerBase blockLayer = block.getLogic();
 
 			final int newMeta = meta + 1;
 
@@ -100,35 +99,34 @@ public class ItemBlockLayer extends ItemBlock
 
 			if (newMeta < 7)
 			{
-				world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, newMeta);
+				world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, block.id(), newMeta);
 			}
 			else
 			{
-				if (blockLayer.getFullBlockID() != -1)
+				if (blockLayer.fullBlock != null)
 				{
-					world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockLayer.getFullBlockID(), 0);
+					world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockLayer.fullBlock.id(), 0);
 				}
 				else
 				{
-					world.setBlockAndMetadataWithNotify(blockX, blockY + 1, blockZ, blockID, 0);
+					world.setBlockAndMetadataWithNotify(blockX, blockY + 1, blockZ, block.id(), 0);
 				}
 			}
-			world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockLayer, EnumBlockSoundEffectType.PLACE);
+			world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
 			itemstack.consumeItem(player);
 			return true;
 		}
 
 		// Regular placement, as all else fails
-		if (world.canBlockBePlacedAt(blockID, blockX, blockY, blockZ, false, side))
+		if (world.canBlockBePlacedAt(block.id(), blockX, blockY, blockZ, false, side))
 		{
-			final Block block = Blocks.blocksList[blockID];
 			int placeMeta = getPlacedBlockMetadata(player, itemstack, world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
-			if (world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, placeMeta))
+			if (world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, block.id(), placeMeta))
 			{
 				if (player == null) {
-					Blocks.blocksList[blockID].onBlockPlacedOnSide(world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
+					block.onBlockPlacedOnSide(world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
 				} else {
-					Blocks.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, Side.NONE, player, xPlaced, yPlaced);
+					block.onBlockPlacedByMob(world, blockX, blockY, blockZ, Side.NONE, player, xPlaced, yPlaced);
 				}
 				world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
 				itemstack.consumeItem(player);
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java
index d189a96cc..2515d87a0 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java
@@ -1,10 +1,9 @@
 package net.minecraft.core.item.block;
 
-import net.minecraft.core.block.BlockLayerBase;
-import net.minecraft.core.block.BlockLeavesBase;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockLayerLeaves;
-import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.BlockLogicLayerBase;
+import net.minecraft.core.block.BlockLogicLayerLeaves;
+import net.minecraft.core.block.BlockLogicLeavesBase;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
@@ -14,9 +13,9 @@ import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
-public class ItemBlockLayerLeaves extends ItemBlock
+public class ItemBlockLayerLeaves<T extends BlockLogicLayerLeaves> extends ItemBlock<T>
 {
-	public ItemBlockLayerLeaves(Block block)
+	public ItemBlockLayerLeaves(Block<T> block)
 	{
 		super(block);
 	}
@@ -24,27 +23,27 @@ public class ItemBlockLayerLeaves extends ItemBlock
 	@Override
 	public boolean onUseItemOnBlock(final ItemStack itemstack, final Player player, final World world, int blockX, int blockY, int blockZ, final Side side, double xPlaced, final double yPlaced)
 	{
-		int id = world.getBlockId(blockX, blockY, blockZ);
+		Block<?> targetBlock = world.getBlock(blockX, blockY, blockZ);
 		int meta = world.getBlockMetadata(blockX, blockY, blockZ);
-		if (id != blockID && Blocks.blocksList[id] != null && Blocks.blocksList[id].hasTag(BlockTags.PLACE_OVERWRITES))
+		if (targetBlock != block && targetBlock != null && targetBlock.hasTag(BlockTags.PLACE_OVERWRITES))
 		{
-			id = 0;
+			targetBlock = null;
 			meta = 0;
 		}
 		if (itemstack.stackSize <= 0)
 		{
 			return false;
 		}
-		if (blockY == world.getHeightBlocks() - 1 && Blocks.blocksList[blockID].blockMaterial.isSolid())
+		if (blockY == world.getHeightBlocks() - 1 && block.getMaterial().isSolid())
 		{
 			return false;
 		}
 
 		// Check if we're placing "inside" a layer
-		if (id == blockID && side == Side.TOP)
+		if (targetBlock == block && side == Side.TOP)
 		{
 
-			final BlockLayerBase blockLayer = (BlockLayerBase) Blocks.blocksList[blockID];
+			final BlockLogicLayerBase blockLayer = block.getLogic();
 
 			final int newMeta = meta + 1;
 
@@ -56,40 +55,40 @@ public class ItemBlockLayerLeaves extends ItemBlock
 
 			if ((newMeta & 0b00001111) < 7)
 			{
-				world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, BlockLayerLeaves.setPermanent(newMeta, true));
+				world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, block.id(), BlockLogicLayerLeaves.setPermanent(newMeta, true));
 			}
 			else
 			{
-				if (blockLayer.getFullBlockID() != -1)
+				if (blockLayer.fullBlock != null)
 				{
-					world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockLayer.getFullBlockID(), BlockLeavesBase.setPermanent(0, true));
+					world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockLayer.fullBlock.id(), BlockLogicLeavesBase.setPermanent(0, true));
 				}
 				else
 				{
-					world.setBlockAndMetadataWithNotify(blockX, blockY + 1, blockZ, blockID, BlockLayerLeaves.setPermanent(0, true));
+					world.setBlockAndMetadataWithNotify(blockX, blockY + 1, blockZ, block.id(), BlockLogicLayerLeaves.setPermanent(0, true));
 				}
 			}
-			world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockLayer, EnumBlockSoundEffectType.PLACE);
+			world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
 			itemstack.consumeItem(player);
 			return true;
 
 		}
 
 		// Offset position
-		if (id != 0)
+		if (targetBlock != null)
 		{
 			blockX += side.getOffsetX();
 			blockY += side.getOffsetY();
 			blockZ += side.getOffsetZ();
-			id = world.getBlockId(blockX, blockY, blockZ);
+			targetBlock = world.getBlock(blockX, blockY, blockZ);
 			meta = world.getBlockMetadata(blockX, blockY, blockZ);
 		}
 
 		// Check if the block we're placing into is a layer
-		if (id == blockID)
+		if (targetBlock == block)
 		{
 
-			final BlockLayerBase blockLayer = (BlockLayerBase) Blocks.blocksList[blockID];
+			final BlockLogicLayerBase blockLayer = block.getLogic();
 
 			final int newMeta = meta + 1;
 
@@ -101,35 +100,34 @@ public class ItemBlockLayerLeaves extends ItemBlock
 
 			if ((newMeta & 0b00001111) < 7)
 			{
-				world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, BlockLayerLeaves.setPermanent(newMeta, true));
+				world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, block.id(), BlockLogicLayerLeaves.setPermanent(newMeta, true));
 			}
 			else
 			{
-				if (blockLayer.getFullBlockID() != -1)
+				if (blockLayer.fullBlock != null)
 				{
-					world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockLayer.getFullBlockID(), BlockLeavesBase.setPermanent(0, true));
+					world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockLayer.fullBlock.id(), BlockLogicLeavesBase.setPermanent(0, true));
 				}
 				else
 				{
-					world.setBlockAndMetadataWithNotify(blockX, blockY + 1, blockZ, blockID, BlockLayerLeaves.setPermanent(0, true));
+					world.setBlockAndMetadataWithNotify(blockX, blockY + 1, blockZ, block.id(), BlockLogicLayerLeaves.setPermanent(0, true));
 				}
 			}
-			world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockLayer, EnumBlockSoundEffectType.PLACE);
+			world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
 			itemstack.consumeItem(player);
 			return true;
 		}
 
 		// Regular placement, as all else fails
-		if (world.canBlockBePlacedAt(blockID, blockX, blockY, blockZ, false, side))
+		if (world.canBlockBePlacedAt(block.id(), blockX, blockY, blockZ, false, side))
 		{
-			final Block block = Blocks.blocksList[blockID];
 			int placeMeta = getPlacedBlockMetadata(player, itemstack, world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
-			if (world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, placeMeta))
+			if (world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, this.block.id(), placeMeta))
 			{
 				if (player == null) {
-					Blocks.blocksList[blockID].onBlockPlacedOnSide(world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
+					block.onBlockPlacedOnSide(world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
 				} else {
-					Blocks.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, xPlaced, yPlaced);
+					block.onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, xPlaced, yPlaced);
 				}
 				world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
 				itemstack.consumeItem(player);
@@ -142,7 +140,7 @@ public class ItemBlockLayerLeaves extends ItemBlock
 	
 	@Override
 	public int getPlacedBlockMetadata(@Nullable Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
-		return BlockLayerLeaves.MASK_PERMANENT;
+		return BlockLogicLayerLeaves.MASK_PERMANENT;
 	}
 
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockPainted.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockPainted.java
index d69af94ac..8137681df 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockPainted.java
@@ -1,14 +1,15 @@
 package net.minecraft.core.item.block;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DyeColor;
 
-public class ItemBlockPainted extends ItemBlock
+public class ItemBlockPainted<T extends BlockLogic> extends ItemBlock<T>
 {
 	private final boolean upperMetadata;
 	
-    public ItemBlockPainted(Block block, boolean upperMetadata)
+    public ItemBlockPainted(Block<T> block, boolean upperMetadata)
     {
         super(block);
         setMaxDamage(0);
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
index a18eeac44..f7cfc2be5 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.item.block;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
@@ -11,10 +12,10 @@ import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
-public class ItemBlockSlab extends ItemBlock
+public class ItemBlockSlab<T extends BlockLogic> extends ItemBlock<T>
 {
 
-    public ItemBlockSlab(Block block)
+    public ItemBlockSlab(Block<T> block)
     {
         super(block);
     }
@@ -34,13 +35,13 @@ public class ItemBlockSlab extends ItemBlock
         {
             return false;
         }
-        if(blockY == world.getHeightBlocks() - 1 && Blocks.blocksList[blockID].blockMaterial.isSolid())
+        if(blockY == world.getHeightBlocks() - 1 && block.getMaterial().isSolid())
         {
             return false;
         }
 
         // Check if we're placing "inside" a slab
-        if (id == blockID && otherMeta == itemstack.getMetadata() && (side == Side.TOP || side == Side.BOTTOM))
+        if (id == block.id() && otherMeta == itemstack.getMetadata() && (side == Side.TOP || side == Side.BOTTOM))
         {
         	if ((side == Side.TOP && meta == 0) || (side == Side.BOTTOM && meta == 2))
         	{
@@ -48,9 +49,8 @@ public class ItemBlockSlab extends ItemBlock
                 if(!world.checkIfAABBIsClear(bbBox))
                     return false;
 
-        		Block blockSlab = Blocks.blocksList[blockID];
         		world.setBlockMetadataWithNotify(blockX, blockY, blockZ, 1 | itemstack.getMetadata());
-                world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockSlab, EnumBlockSoundEffectType.PLACE);
+                world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
             	itemstack.consumeItem(player);
             	return true;
         	}
@@ -68,7 +68,7 @@ public class ItemBlockSlab extends ItemBlock
         }
 
         // Check if the block we're placing into is a slab
-        if (id == blockID && otherMeta == itemstack.getMetadata())
+        if (id == block.id() && otherMeta == itemstack.getMetadata())
         {
         	if ((yPlaced > 0.5f && meta == 0) || (yPlaced <= 0.5f && meta == 2) || (side == Side.BOTTOM && meta == 0) || (side == Side.TOP && meta == 2))
         	{
@@ -76,25 +76,23 @@ public class ItemBlockSlab extends ItemBlock
                 if(!world.checkIfAABBIsClear(bbBox))
                     return false;
 
-        		Block blockSlab = Blocks.blocksList[blockID];
         		world.setBlockMetadataWithNotify(blockX, blockY, blockZ, 1 | itemstack.getMetadata());
-                world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockSlab, EnumBlockSoundEffectType.PLACE);
+                world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
                 itemstack.consumeItem(player);
             	return true;
         	}
         }
 
         // Regular placement, as all else fails
-        if(world.canBlockBePlacedAt(blockID, blockX, blockY, blockZ, false, side))
+        if(world.canBlockBePlacedAt(block.id(), blockX, blockY, blockZ, false, side))
         {
-            Block block = Blocks.blocksList[blockID];
             int placeMeta = getPlacedBlockMetadata(player, itemstack, world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
-            if(world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, placeMeta))
+            if(world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, this.block.id(), placeMeta))
             {
                 if (player == null) {
-                    Blocks.blocksList[blockID].onBlockPlacedOnSide(world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
+                    block.onBlockPlacedOnSide(world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
                 } else {
-                    Blocks.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, xPlaced, yPlaced);
+                    block.onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, xPlaced, yPlaced);
                 }
                 world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
                 itemstack.consumeItem(player);
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlabPainted.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlabPainted.java
index b5cfe3993..7f57b0bbe 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlabPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlabPainted.java
@@ -1,14 +1,15 @@
 package net.minecraft.core.item.block;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DyeColor;
 
-public class ItemBlockSlabPainted extends ItemBlockSlab
+public class ItemBlockSlabPainted<T extends BlockLogic> extends ItemBlockSlab<T>
 {
 	private final boolean upperMetadata;
 	
-    public ItemBlockSlabPainted(Block block)
+    public ItemBlockSlabPainted(Block<T> block)
     {
         super(block);
         setMaxDamage(0);
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockStairsPainted.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockStairsPainted.java
index 0cfa3c679..d1a672086 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockStairsPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockStairsPainted.java
@@ -1,16 +1,17 @@
 package net.minecraft.core.item.block;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-public class ItemBlockStairsPainted extends ItemBlock
+public class ItemBlockStairsPainted<T extends BlockLogic> extends ItemBlock<T>
 {
 
-    public ItemBlockStairsPainted(Block block)
+    public ItemBlockStairsPainted(Block<T> block)
     {
         super(block);
         setMaxDamage(0);
diff --git a/game/core/src/main/java/net/minecraft/core/item/tool/ItemTool.java b/game/core/src/main/java/net/minecraft/core/item/tool/ItemTool.java
index 84341cb2d..7ee3bd957 100644
--- a/game/core/src/main/java/net/minecraft/core/item/tool/ItemTool.java
+++ b/game/core/src/main/java/net/minecraft/core/item/tool/ItemTool.java
@@ -15,12 +15,12 @@ import net.minecraft.core.world.World;
 public class ItemTool extends Item
 {
 
-	private final Tag<Block> tagEffectiveAgainst;
+	private final Tag<Block<?>> tagEffectiveAgainst;
 	private final int damageVsEntity;
 	protected ToolMaterial material;
 
 	@SuppressWarnings("unchecked")
-	protected ItemTool(String name, String namespaceId, int id, int damageDealt, ToolMaterial toolMaterial, Tag<Block> tagEffectiveAgainst) {
+	protected ItemTool(String name, String namespaceId, int id, int damageDealt, ToolMaterial toolMaterial, Tag<Block<?>> tagEffectiveAgainst) {
 		super(name, namespaceId, id);
 		this.material = toolMaterial;
 		this.tagEffectiveAgainst = tagEffectiveAgainst;
@@ -32,7 +32,7 @@ public class ItemTool extends Item
 	}
 
 	@Override
-	public float getStrVsBlock(ItemStack itemstack, Block block) {
+	public float getStrVsBlock(ItemStack itemstack, Block<?> block) {
 		if(block.hasTag(tagEffectiveAgainst))
 			return material.getEfficiency(false);
 
@@ -40,14 +40,14 @@ public class ItemTool extends Item
 	}
 
 	@Override
-	public boolean hitEntity(ItemStack itemstack, Mob entityliving, Mob entityliving1) {
-		itemstack.damageItem(2, entityliving1);
+	public boolean hitEntity(ItemStack itemstack, Mob target, Mob attacker) {
+		itemstack.damageItem(2, attacker);
 		return true;
 	}
 
 	@Override
 	public boolean onBlockDestroyed(World world, ItemStack itemstack, int i, int x, int y, int z, Side side, Mob mob) {
-		Block block = Blocks.blocksList[i];
+		Block<?> block = Blocks.blocksList[i];
 		if(block != null) {
 			if(block.getHardness() > 0.0f || isSilkTouch()) {
 				itemstack.damageItem(1, mob);
diff --git a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolAxe.java b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolAxe.java
index 6a9750bcf..eac76dd9d 100644
--- a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolAxe.java
+++ b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolAxe.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.item.tool;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockLog;
+import net.minecraft.core.block.BlockLogicLog;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.data.gamerule.GameRules;
@@ -22,7 +22,7 @@ public class ItemToolAxe extends ItemTool
     }
 
     @Override
-    public boolean canHarvestBlock(Mob entityLiving, ItemStack itemStack, Block block)
+    public boolean canHarvestBlock(Mob mob, ItemStack itemStack, Block<?> block)
     {
         return block.hasTag(BlockTags.MINEABLE_BY_AXE);
     }
@@ -32,7 +32,7 @@ public class ItemToolAxe extends ItemTool
     {
     	if(!world.isClientSide && world.getGameRuleValue(GameRules.TREECAPITATOR) && !player.isSneaking()) {
     		int id = world.getBlockId(x, y, z);
-    		if(Blocks.getBlock(id) instanceof BlockLog) {
+    		if(Block.hasLogicClass(Blocks.getBlock(id), BlockLogicLog.class)) {
             	return !new TreecapitatorHelper(world, x, y, z, player).chopTree();
     		}
     	}
diff --git a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolHoe.java b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolHoe.java
index a8f8a59a9..ac0240994 100644
--- a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolHoe.java
+++ b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolHoe.java
@@ -28,7 +28,7 @@ public class ItemToolHoe extends ItemTool
     }
 
     @Override
-    public boolean canHarvestBlock(Mob entityLiving, ItemStack itemStack, Block block)
+    public boolean canHarvestBlock(Mob mob, ItemStack itemStack, Block<?> block)
     {
         return block.hasTag(BlockTags.MINEABLE_BY_HOE);
     }
@@ -42,15 +42,14 @@ public class ItemToolHoe extends ItemTool
     public boolean till(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side) {
         int id = world.getBlockId(blockX, blockY, blockZ);
         int j1 = world.getBlockId(blockX, blockY + 1, blockZ);
-        if(side != Side.BOTTOM && j1 == 0 && (id == Blocks.GRASS.id || id == Blocks.DIRT.id || id == Blocks.PATH_DIRT.id || id == Blocks.GRASS_RETRO.id || id == Blocks.MUD.id))
+        if(side != Side.BOTTOM && j1 == 0 && (id == Blocks.GRASS.id() || id == Blocks.DIRT.id() || id == Blocks.PATH_DIRT.id() || id == Blocks.GRASS_RETRO.id() || id == Blocks.MUD.id()))
         {
             int meta = 0;
-            if(id == Blocks.MUD.id)
+            if(id == Blocks.MUD.id())
                 meta = 1;
-            Block block = Blocks.FARMLAND_DIRT;
             world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.DIRT, EnumBlockSoundEffectType.MINE);
             if(!world.isClientSide) {
-                if(id == Blocks.GRASS.id || id == Blocks.GRASS_RETRO.id || id == Blocks.GRASS_SCORCHED.id) {
+                if(id == Blocks.GRASS.id() || id == Blocks.GRASS_RETRO.id() || id == Blocks.GRASS_SCORCHED.id()) {
                     if(world.rand.nextInt(5) == 0) {
                         world.dropItem(blockX, blockY + 1, blockZ, new ItemStack(Items.SEEDS_WHEAT));
                     }
@@ -61,7 +60,7 @@ public class ItemToolHoe extends ItemTool
                 return true;
             } else
             {
-                world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, block.id, meta);
+                world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.FARMLAND_DIRT.id(), meta);
                 itemstack.damageItem(1, player);
                 return true;
             }
@@ -79,7 +78,7 @@ public class ItemToolHoe extends ItemTool
     @Override
     public boolean onBlockDestroyed(World world, ItemStack itemstack, int id, int x, int y, int z, Side side, Mob mob) {
     	if(mob != null && !mob.world.isClientSide) {
-        	if(id == Blocks.TALLGRASS.id || id == Blocks.TALLGRASS_FERN.id) {
+        	if(id == Blocks.TALLGRASS.id() || id == Blocks.TALLGRASS_FERN.id()) {
         		if(this.material.isSilkTouch()) {
         			mob.world.dropItem(x, y, z, new ItemStack(Item.itemsList[id]));
             		itemstack.damageItem(1, mob);
diff --git a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolPickaxe.java b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolPickaxe.java
index 4bea3675b..0b2bae886 100644
--- a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolPickaxe.java
+++ b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolPickaxe.java
@@ -12,7 +12,7 @@ import net.minecraft.core.item.material.ToolMaterial;
 
 public class ItemToolPickaxe extends ItemTool {
 	
-	public static Map<Block, Integer> miningLevels = new HashMap<>();
+	public static Map<Block<?>, Integer> miningLevels = new HashMap<>();
 	
 	static {
 		miningLevels.put(Blocks.OBSIDIAN, 3);
@@ -61,7 +61,7 @@ public class ItemToolPickaxe extends ItemTool {
 	}
 
 	@Override
-	public boolean canHarvestBlock(Mob entityLiving, ItemStack itemStack, Block block)
+	public boolean canHarvestBlock(Mob mob, ItemStack itemStack, Block<?> block)
 	{
 		Integer miningLevel = miningLevels.get(block);
 		if(miningLevel != null) return material.getMiningLevel() >= miningLevel;
diff --git a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShears.java b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShears.java
index 58ba5b5e3..f0f28e0b8 100644
--- a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShears.java
+++ b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShears.java
@@ -1,9 +1,8 @@
 package net.minecraft.core.item.tool;
 
-import net.minecraft.core.block.BlockLeavesBase;
+import net.minecraft.core.block.BlockLogicLeavesBase;
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.tag.BlockTags;
-import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.animal.MobSheep;
 import net.minecraft.core.item.Item;
@@ -33,15 +32,15 @@ public class ItemToolShears extends Item
     }
 
     @Override
-    public boolean canHarvestBlock(Mob entityLiving, ItemStack itemStack, Block block)
+    public boolean canHarvestBlock(Mob mob, ItemStack itemStack, Block<?> block)
     {
         return block.hasTag(BlockTags.MINEABLE_BY_SHEARS);
     }
 
     @Override
-    public float getStrVsBlock(ItemStack itemstack, Block block)
+    public float getStrVsBlock(ItemStack itemstack, Block<?> block)
     {
-        if(block.id == Blocks.COBWEB.id || block instanceof BlockLeavesBase)
+        if(block == Blocks.COBWEB || Block.hasLogicClass(block, BlockLogicLeavesBase.class))
         {
             return 15F;
         }
@@ -59,9 +58,9 @@ public class ItemToolShears extends Item
         blockY += direction.getOffsetY();
         blockZ += direction.getOffsetZ();
         AABB box = AABB.getTemporaryBB(blockX, blockY, blockZ, blockX + 1, blockY + 1, blockZ + 1);
-        List<Entity> entities = world.getEntitiesWithinAABB(MobSheep.class, box);
+        List<MobSheep> entities = world.getEntitiesWithinAABB(MobSheep.class, box);
         if (!entities.isEmpty()) {
-            ((MobSheep)(entities.get(0))).onItemInteract(itemStack);
+            entities.get(0).onItemInteract(itemStack);
         }
     }
 }
